Developer Documentation

Classes | Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Attributes | Private Types | Static Private Attributes | List of all members
PropertyNameListModel Class Reference
Inheritance diagram for PropertyNameListModel:

## Classes
class | PROP_INFO
class | TypeInfoWrapper

## Public Types
enum | ENTITY_FILTER { EF_ANY = 0x0F, EF_FACE = 0x01, EF_EDGE = 0x02, EF_HALFEDGE = 0x04, EF_VERTEX = 0x08 }

## Public Member Functions
| PropertyNameListModel (QObject *parent=0)
virtual int | rowCount (const QModelIndex &parent=QModelIndex()) const
virtual QVariant | data (const QModelIndex &index, int role=Qt::DisplayRole) const
virtual QVariant | headerData (int section, Qt::Orientation orientation, int role=Qt::DisplayRole) const
template<typename MeshT >
void | refresh (MeshT *mesh, ENTITY_FILTER entityFilterMask, std::type_info *typeIdFilter)
bool | tryInsertionsDeletions (std::vector< PROP_INFO > &propList)
template<typename MeshT , typename OUTPUT_ITERATOR >
void | gatherProperties (MeshT *mesh, typename MeshT::prop_iterator props_first, typename MeshT::prop_iterator props_last, std::type_info *typeIdFilter, OUTPUT_ITERATOR oit, ENTITY_FILTER entity)
const PROP_INFO & | operator[] (size_t index)

## Static Public Member Functions
static const char * | entity2str (ENTITY_FILTER entity)

## Static Public Attributes
static const TypeInfoWrapper | proptype_bool
static const TypeInfoWrapper | proptype_int
static const TypeInfoWrapper | proptype_uint
static const TypeInfoWrapper | proptype_double
static const TypeInfoWrapper | proptype_Vec3d
static const TypeInfoWrapper | proptype_Vec3f
static const TypeInfoWrapper | proptype_Vec2d
static const TypeInfoWrapper | proptype_Vec2f
static const TypeInfoWrapper | proptype_Matrix3x3d
static const TypeInfoWrapper | proptype_SkinWeights

## Protected Attributes
std::vector< PROP_INFO > | propList_

## Private Types
typedef std::set< TypeInfoWrapper > | TYPE_INFO_SET

## Static Private Attributes
static const TypeInfoWrapper | prop_types []
static const TYPE_INFO_SET | sane_prop_types

## Detailed Description

Definition at line 54 of file PropertyNameListModel.hh.

## Member Function Documentation

## ◆ refresh()

template<typename MeshT >

void PropertyNameListModel::refresh | ( | MeshT * | mesh,
|  | ENTITY_FILTER | entityFilterMask,
|  | std::type_info * | typeIdFilter
| ) |  |
| inline

Parameters

  mesh | The mesh to work on
  entityFilterMask | Filter mask
  typeIdFilter | If NULL, do not filter by type.

Definition at line 148 of file PropertyNameListModel.hh.

## ◆ tryInsertionsDeletions()

bool PropertyNameListModel::tryInsertionsDeletions | ( | std::vector< PROP_INFO > & | propList | ) |

Implements an unsophisticated heuristic to translate the difference between propList and propList_ into a series of insertions and deletions.

Returns
  True if such a sequence was found, false otherwise.

Definition at line 157 of file PropertyNameListModel.cc.

## Member Data Documentation

## ◆ prop_types

const PropertyNameListModel::TypeInfoWrapper PropertyNameListModel::prop_types
| static private

Initial value:
= {
proptype_bool,
proptype_int,
proptype_uint,
proptype_double,
proptype_Vec3d,
proptype_Vec3f,
proptype_Vec2d,
proptype_Vec2f,
}

Definition at line 223 of file PropertyNameListModel.hh.

## ◆ proptype_bool

const PropertyNameListModel::TypeInfoWrapper PropertyNameListModel::proptype_bool
| static

Initial value:
=
PropertyNameListModel::TypeInfoWrapper(typeid(OpenMesh::PropertyT<bool>), "bool")

Definition at line 210 of file PropertyNameListModel.hh.

## ◆ proptype_double

const PropertyNameListModel::TypeInfoWrapper PropertyNameListModel::proptype_double
| static

Initial value:
=
PropertyNameListModel::TypeInfoWrapper(typeid(OpenMesh::PropertyT<double>), "double")

Definition at line 213 of file PropertyNameListModel.hh.

## ◆ proptype_int

const PropertyNameListModel::TypeInfoWrapper PropertyNameListModel::proptype_int
| static

Initial value:
=
PropertyNameListModel::TypeInfoWrapper(typeid(OpenMesh::PropertyT<int>), "int")

Definition at line 211 of file PropertyNameListModel.hh.

## ◆ proptype_Matrix3x3d

const PropertyNameListModel::TypeInfoWrapper PropertyNameListModel::proptype_Matrix3x3d
| static

Initial value:
=
PropertyNameListModel::TypeInfoWrapper(typeid(OpenMesh::PropertyT<ACG::Matrix3x3d>), "Matrix3x3d")

Definition at line 218 of file PropertyNameListModel.hh.

## ◆ proptype_uint

const PropertyNameListModel::TypeInfoWrapper PropertyNameListModel::proptype_uint
| static

Initial value:
=
PropertyNameListModel::TypeInfoWrapper(typeid(OpenMesh::PropertyT<unsigned int>), "unsigned int")

Definition at line 212 of file PropertyNameListModel.hh.

## ◆ proptype_Vec2d

const PropertyNameListModel::TypeInfoWrapper PropertyNameListModel::proptype_Vec2d
| static

Initial value:
=
PropertyNameListModel::TypeInfoWrapper(typeid(OpenMesh::PropertyT<ACG::Vec2d>), "Vec2d")

Definition at line 216 of file PropertyNameListModel.hh.

## ◆ proptype_Vec2f

const PropertyNameListModel::TypeInfoWrapper PropertyNameListModel::proptype_Vec2f
| static

Initial value:
=
PropertyNameListModel::TypeInfoWrapper(typeid(OpenMesh::PropertyT<ACG::Vec2f>), "Vec2f")

Definition at line 217 of file PropertyNameListModel.hh.

## ◆ proptype_Vec3d

const PropertyNameListModel::TypeInfoWrapper PropertyNameListModel::proptype_Vec3d
| static

Initial value:
=
PropertyNameListModel::TypeInfoWrapper(typeid(OpenMesh::PropertyT<ACG::Vec3d>), "Vec3d")

Definition at line 214 of file PropertyNameListModel.hh.

## ◆ proptype_Vec3f

const PropertyNameListModel::TypeInfoWrapper PropertyNameListModel::proptype_Vec3f
| static

Initial value:
=
PropertyNameListModel::TypeInfoWrapper(typeid(OpenMesh::PropertyT<ACG::Vec3f>), "Vec3f")

Definition at line 215 of file PropertyNameListModel.hh.

The documentation for this class was generated from the following files:

- Plugin-PropertyVis/Models/PropertyNameListModel.hh
- Plugin-PropertyVis/Models/PropertyNameListModel.cc